﻿/**
 * rutor.org plugin for Movian Media Center
 *
 *  Copyright (C) 2015 lprot
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

(function(plugin) {
    var logo = plugin.path + "logo.png";

    var blue = '6699CC', orange = 'FFA500', red = 'EE0000', green = '66ff72';

    function colorStr(str, color) {
        return '<font color="' + color + '"> (' + str + ')</font>';
    }

    function coloredStr(str, color) {
        return '<font color="' + color + '">' + str + '</font>';
    }

    function setPageHeader(page, title) {
        if (page.metadata) {
            page.metadata.title = title;
            page.metadata.logo = logo;
        }
        page.type = "directory";
        page.contents = "items";
        page.loading = false;
    }

    var service = plugin.createService(plugin.getDescriptor().title, plugin.getDescriptor().id + ":start", "video", true, logo);

    var settings = plugin.createSettings(plugin.getDescriptor().title, logo, plugin.getDescriptor().synopsis);

    settings.createString('baseURL', "Base URL without '/' at the end.", 'http://zerkalo-rutor.org', function(v) {
        service.baseURL = v;
    });


    function list(page, doc) {
        // 1-date, 2-filelink, 3-infolink, 4-title, 5-(1)size, (2)seeds, (3)peers
        var re = /<tr class="[gai|tum]+"><td>([\s\S]*?)<\/td>[\s\S]*?href="([\s\S]*?)"[\s\S]*?<a href[\s\S]*?<a href="([\s\S]*?)">([\s\S]*?)<\/a>([\s\S]*?)<\/tr>/g;
        var match = re.exec(doc);
        while (match) {
            if (match[5].match(/alt="C"/)) {
                var end = match[5].match(/[\s\S]*?<td align="right">[\s\S]*?<td align="right">([\s\S]*?)<[\s\S]*?nbsp;([\s\S]*?)<\/span>[\s\S]*?nbsp;([\s\S]*?)<\/span>/);
                var comments = match[5].match(/[\s\S]*?<td align="right">([\s\S]*?)</)[1];
            } else
                var end = match[5].match(/[\s\S]*?<td align="right">([\s\S]*?)<[\s\S]*?nbsp;([\s\S]*?)<\/span>[\s\S]*?nbsp;([\s\S]*?)<\/span>/);
            var url = service.baseURL + match[3];
            if (match[3].match(/http:\/\//))
                url = match[3].match(/(\/download.*)/)[1];
            page.appendItem(plugin.getDescriptor().id +':list:' + url, "directory", {title: new showtime.RichText(colorStr(match[1], orange) + ' ' +match[4] + coloredStr(end[2], green) + '/'+coloredStr(end[3], red) + colorStr(end[1], blue) +(comments ? colorStr(comments, orange) : ''))});
           	page.entries++;
            match = re.exec(doc);
        }
    }


   
	function scraper(page, doc) {
        // 1-date, 2-filelink, 3-infolink, 4-title, 5-(1)size, (2)seeds, (3)peers
        var head= /::([\s\S]*?)<\/title[\s\S]*?<[\s\S]*?mail[\s\S]*?a href="([\s\S]*?)"[\s\S]*?/g;
		
		var desc = /(?:О фильме|Описание[ фильма]*|фильма)([\s\S]*?)\n([\s\S]*?)\n/;
		var match1 = head.exec(doc);
		var jshdgf = '';
		var poster = '';
		var trim = /(?:<[\s\S]*?>[ :]*)+([\s\S]*?)(?:<[\s\S]*?>)+/g;
		var trim1 = /<table id="details">[\s\S]*?468[\s\S]*?"[\s\S]*?src="([\s\S]*?)"/;

		try 		
		{sdfsd = desc.exec(doc)[1]+desc.exec(doc)[2];
		jshdgf = trim.exec(sdfsd)[1];
		poster = (trim1).exec(doc)[1]
		}catch(e){}
		while (match1) {
            
            var url = service.baseURL + match1[2];
            if (match1[2].match(/http:\/\//))
                url = service.baseURL + match1[2].match(/(\/download.*)/)[1];
            page.appendItem('torrent:browse:' + url, "video", 
			{
			title: new showtime.RichText(coloredStr(match1[1], orange)),  
			description: jshdgf,
			icon: poster
			});
			
            page.entries++;
            match1 = head.exec(doc);
        }
		
		
		
		var actors = /жиссер[\s\S]*?(?:ктеры|ролях)+[<>:\/b ]{2,7}[\s\S]*?\B[А-я][\s\S]*?<br \/>/;
		var actors1 = /([А-я \-\.]+(?: (([А-Я][а-я\-\.]*){1,3}(?:\(I*\))?)))/g;
		var match2 = actors.exec(doc);
		var error = false;
		try {var match3 = actors1.exec(match2);} catch(e){var error=true}
		var iconurl = /actor\/+([\d]+).jpg/;
		var kinopoisk = 'https://www.kinopoisk.ru/index.php?kp_query=';
		
		if (!error) try{{
		while (match3) {
            
            var url = '/search/0/0/010/2/' + encodeURI(match3[1]);
			var kinopage = showtime.httpReq(kinopoisk + (match3[1]));
           	page.appendItem(plugin.getDescriptor().id + ':category:' + url + ':' + encodeURI(match3[1]), "video", 
			{		
			title: new showtime.RichText(coloredStr(match3[1], orange)),
			icon: 'https://st.kp.yandex.net/images/sm_actor/' + iconurl.exec(kinopage)[1] + '.jpg'
			
			});
			
            page.entries++;
            match3 = actors1.exec(match2);
        }
		}} catch(e){popup.notify(e,5)}
		
		var re = /<tr class="[gai|tum]+"><td>([\s\S]*?)<\/td>[\s\S]*?href="([\s\S]*?)"[\s\S]*?<a href[\s\S]*?<a href="([\s\S]*?)">([\s\S]*?)<\/a>([\s\S]*?)<\/tr>/g;
        var match = re.exec(doc);
        while (match) {
            if (match[5].match(/alt="C"/)) {
                var end = match[5].match(/[\s\S]*?<td align="right">[\s\S]*?<td align="right">([\s\S]*?)<[\s\S]*?nbsp;([\s\S]*?)<\/span>[\s\S]*?nbsp;([\s\S]*?)<\/span>/);
                var comments = match[5].match(/[\s\S]*?<td align="right">([\s\S]*?)</)[1];
            } else
                var end = match[5].match(/[\s\S]*?<td align="right">([\s\S]*?)<[\s\S]*?nbsp;([\s\S]*?)<\/span>[\s\S]*?nbsp;([\s\S]*?)<\/span>/);
            var url = service.baseURL + match[3];
            if (match[3].match(/http:\/\//))
                url = match[3].match(/(\/download.*)/)[1];
            page.appendItem(plugin.getDescriptor().id +':list:' + url, "directory", {title: new showtime.RichText(coloredStr(match[1], orange) + ' ' +match[4] +  coloredStr(end[2], green) + '/'+coloredStr(end[3], red) +  colorStr(end[1], blue) +(comments ? colorStr(comments, orange) : ''))});
           	page.entries++;
            match = re.exec(doc);
        }
        
    }

		plugin.addURI(plugin.getDescriptor().id + ":random", function(page) {
	        setPageHeader(page, "Случайное кино");
        page.loading = true;
        var doc = showtime.httpReq('https://www.randommovie.ru/').toString();
		var re = /div class="col s12 m4"[\s\S]*?\(([\s\S]*?)\)[\s\S]*?white-text">([\s\S]*?)<[\s\S]*?<p>([\s\S]*?)<[\s\S]*?persons">([\s\S]*?)<p>([\s\S]*?)<\/p>/g;
		
        match = re.exec(doc);
        while (match!=null) {
            page.appendItem(plugin.getDescriptor().id + ':category:' + '/search/0/0/000/2/' + encodeURI(match[2]) + ':' + encodeURI('/search/0/0/010/2/' + encodeURI(match[2])), "video", 
			{		
			title: new showtime.RichText(coloredStr(match[2] + ', ' + match[3], orange)),
			icon: 'https://www.randommovie.ru' + match[1],
			description: match[5]
			
			});
            
           	
			
            page.entries++;
			match = re.exec(doc);
            //match3 = actors1.exec(match2);
        }
        page.loading = false;
    }); 
	
	
	plugin.addURI(plugin.getDescriptor().id + ":category:(.*):(.*)", function(page, url,name) {
	        setPageHeader(page, plugin.getDescriptor().synopsis);
        page.loading = true;
        var doc = showtime.httpReq(service.baseURL + url).toString();
		
        doc = doc.match(/<div id="index">([\s\S]*?)<!-- bottom banner -->/);
        if (doc) {
           var re = /<h2>([\s\S]*?)<tr class="backgr">([\s\S]*?)<\/table>/g;
           var match = re.exec(doc[1]);
           while (match) {
              page.appendItem("", "separator", {title: new showtime.RichText(match[1])});
               list(page, match[2]);
			   match = re.exec(doc[1]);
           }
        }; {list(page, doc)};
        page.loading = false;
    }); 

    plugin.addURI(plugin.getDescriptor().id + ":list:(.*)", function(page, url) {
        setPageHeader(page, plugin.getDescriptor().synopsis);
        page.loading = true;
        var doc = showtime.httpReq(url).toString();
        scraper(page, doc); 
        page.loading = false;
    });


	
	
	
plugin.addURI(plugin.getDescriptor().id + ":start", function (page) {
        //Pages: browse, recent, tv shows, Music, Top 100
        var pages = [
                {
                    url: '/top',
                    name: 'Топ'
                },
                {
                    url: '/new',
                    name: 'Новые'
                },
                {
                    url: "/browse/",
                    name: "Всё"
                },                
                {
                    url: '/kino',
                    name: 'Зарубежные фильмы'
                },
				{
                    url: '/tag/1/Комедия',
                    name: 'Комедия'
                },
                {
                    url: '/jumor',
                    name: 'Юмор'
                },
                {
                    url: '/tag/5/Триллер',
                    name: 'Триллер'
                },
				{
                    url: "/tag/1/Арт-хаус",
                    name: 'Арт-хаус'
                },
                
				{
                    url: '/tag/1/Эротика',
                    name: 'Эротика'
                },
                {
                    url: '/tv',
                    name: 'Телевизор'
                },
                {
                    url: '/seriali',
                    name: 'Сериалы'
                },
                {
                    url: '/audio',
                    name: 'Музыка'
                },
                {
                    url: '//search/0/1/010/0/франция',
                    name: 'Франция'
                }
				
            ],
            i, length = pages.length;
        setPageHeader(page, plugin.getDescriptor().synopsis);
        for (i = 0; i < length; i++) 
		{
            
			page.appendItem(plugin.getDescriptor().id + ":category:" + pages[i].url + ':' + encodeURIComponent(pages[i].name), "directory", { title: pages[i].name});
        
		}
		page.appendItem(plugin.getDescriptor().id + ":random", "directory", { title: 'Случайный фильм'});			
    });
	
    plugin.addSearcher(plugin.getDescriptor().id, logo, function(page, query) {
	page.entries = 0;
	var fromPage = 0, tryToSearch = true;
	
	function loader() {
            if (!tryToSearch) return false;
            page.loading = true;
	    var doc = showtime.httpReq(service.baseURL + "/search/"+ fromPage +"/0/000/0/" + query.replace(/\s/g, '\+')).toString();
	    page.loading = false;
            list(page, doc);
	    if (!doc.match(/downgif/)) return tryToSearch = false;
            fromPage++;
	    return true;
	};
	loader();
	page.paginator = loader;
      });
})(this);